unit Iphlpapi;

interface

uses Windows;

const
  MAX_INTERFACE_NAME_LEN = 256;
  MAXLEN_IFDESCR = 256;
  MAXLEN_PHYSADDR = 8;

type
  PMibIfRow = ^TMibIfRow;
  TMibIfRow = record
    wszName: array [0..MAX_INTERFACE_NAME_LEN-1] of WCHAR;
    dwIndex: DWORD;
    dwType: DWORD;
    dwMtu: DWORD;
    dwSpeed: DWORD;
    dwPhysAddrLen: DWORD;
    bPhysAddr: array [0..MAXLEN_PHYSADDR-1] of Byte;
    dwAdminStatus: DWORD;
    dwOperStatus: DWORD;
    dwLastChange: DWORD;
    dwInOctets: DWORD;
    dwInUcastPkts: DWORD;
    dwInNUcastPkts: DWORD;
    dwInDiscards: DWORD;
    dwInErrors: DWORD;
    dwInUnknownProtos: DWORD;
    dwOutOctets: DWORD;
    dwOutUcastPkts: DWORD;
    dwOutNUcastPkts: DWORD;
    dwOutDiscards: DWORD;
    dwOutErrors: DWORD;
    dwOutQLen: DWORD;
    dwDescrLen: DWORD;
    bDescr: array[0..MAXLEN_IFDESCR-1] of Byte;
  end;

  PMibIfTable = ^TMibIfTable;
  TMibIfTable = record
    dwNumEntries: DWORD;
    table: array [0..0] of TMibIfRow;
  end;

  PMibIpAddrRow = ^TMibIpAddrRow;
  TMibIpAddrRow = record
    dwAddr: DWORD;
    dwIndex: DWORD;
    dwMask: DWORD;
    dwBCastAddr: DWORD;
    dwReasmSize: DWORD;
    unused1: Word;
    wType: Word;
  end;

  PMibIpAddrTable = ^TMibIpAddrTable;
  TMibIpAddrTable = record
    dwNumEntries: DWORD;
    table: array [0..0] of TMibIpAddrRow;
  end;

  PMibTcpRow = ^TMibTcpRow;
  TMibTcpRow = record
    dwState: DWORD;
    dwLocalAddr: DWORD;
    dwLocalPort: DWORD;
    dwRemoteAddr: DWORD;
    dwRemotePort: DWORD;
  end;
  PMibTcpTable = ^TMibTcpTable;
  TMibTcpTable = record
    dwNumEntries: DWORD;
    table: array [0..0] of TMibTcpRow;
  end;

  PMibTcpStats = ^TMibTcpStats;
  TMibTcpStats = record
    dwRtoAlgorithm: DWORD;
    dwRtoMin: DWORD;
    dwRtoMax: DWORD;
    dwMaxConn: DWORD;
    dwActiveOpens: DWORD;
    dwPassiveOpens: DWORD;
    dwAttemptFails: DWORD;
    dwEstabResets: DWORD;
    dwCurrEstab: DWORD;
    dwInSegs: DWORD;
    dwOutSegs: DWORD;
    dwRetransSegs: DWORD;
    dwInErrs: DWORD;
    dwOutRsts: DWORD;
    dwNumConns: DWORD;
  end;

  PMibUdpRow = ^TMibUdpRow;
  TMibUdpRow = record
    dwLocalAddr: DWORD;
    dwLocalPort: DWORD;
  end;

  PMibUdpTable = ^TMibUdpTable;
  TMibUdpTable = record
    dwNumEntries: DWORD;
    table: array [0..0] of TMibUdpRow;
  end;

  PMibUdpStats = ^TMibUdpStats;
  TMibUdpStats = record
    dwInDatagrams: DWORD;
    dwNoPorts: DWORD;
    dwInErrors: DWORD;
    dwOutDatagrams: DWORD;
    dwNumAddrs: DWORD;
  end;

var
  GetIfTable: function (pIfTable: PMibIfTable; var pdwSize: ULONG;
      bOrder: BOOL): DWORD; stdcall;
  GetIpAddrTable: function (pIpAddrTable: PMibIpAddrTable; var pdwSize: ULONG;
      bOrder: BOOL): DWORD; stdcall;
  GetTcpTable: function (pTcpTable: PMibTcpTable; var pdwSize: DWORD;
      bOrder: BOOL): DWORD; stdcall;
  GetTcpStatistics: function (var Stats: TMibTcpStats): DWORD; stdcall;
  GetUdpTable: function (pUdpTable: PMibUdpTable; var pdwSize: DWORD;
      bOrder: BOOL): DWORD; stdcall;
  GetUdpStatistics: function (var Stats: TMibUdpStats): DWORD; stdcall;

implementation

var
  Handle: THandle;
begin
  Handle := LoadLibrary('iphlpapi.dll');
  if Handle <> 0 then
  begin
    GetIfTable := GetProcAddress(Handle, 'GetIfTable');
    GetIpAddrTable := GetProcAddress(Handle, 'GetIpAddrTable');
    GetTcpTable := GetProcAddress(Handle, 'GetTcpTable');
    GetTcpStatistics := GetProcAddress(Handle, 'GetTcpStatistics');
    GetUdpTable := GetProcAddress(Handle, 'GetUdpTable');
    GetUdpStatistics := GetProcAddress(Handle, 'GetUdpStatistics');
  end;
end.
